<?php
namespace bwdpsPhotoStack\Widgets;

use Elementor\Widget_Base;
use Elementor\Controls_Manager;

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

class bwdps_photostack extends Widget_Base {

	public function get_name() {
		return esc_html__( 'bwdps_photo_stack', 'bwdps-Photo-Stack' );
	}

	public function get_title() {
		return esc_html__( 'Photo Stack', 'elementor' );
	}

	public function get_icon() {
		return ' eicon-image-rollover bwdps-photo-stack-icon';
	}

	public function get_categories() {
		return ['bwdps-photostack-category'];
	}


	protected function register_controls() {

		//tab-content
		$this->start_controls_section(
			'bwdps_content_section',
			[
				'label' => esc_html__( 'All Style Here', 'bwdps-Photo-Stack' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		//Select Style
		$this->add_control(
			'bwdps_style_selection',
			[
				'label' => esc_html__( 'Select Style', 'bwdps-Photo-Stack' ),
				'type' => Controls_Manager::SELECT,
				'default' => 'style1',
				'options' => [
					'style1' => esc_html__( 'Style 1', 'bwdps-Photo-Stack' ),
					'style2' => esc_html__( 'Style 2', 'bwdps-Photo-Stack' ),
					'style3' => esc_html__( 'Style 3', 'bwdps-Photo-Stack' ),
					'style4' => esc_html__( 'Style 4', 'bwdps-Photo-Stack' ),
					'style5' => esc_html__( 'Style 5', 'bwdps-Photo-Stack' ),
					'style6' => esc_html__( 'Style 6', 'bwdps-Photo-Stack' ),
					'style7' => esc_html__( 'Style 7', 'bwdps-Photo-Stack' ),
					'style8' => esc_html__( 'Style 8', 'bwdps-Photo-Stack' ),
					'style9' => esc_html__( 'Style 9', 'bwdps-Photo-Stack' ),
					'style10' => esc_html__( 'Style 10', 'bwdps-Photo-Stack' ),
					'style11' => esc_html__( 'Style 11', 'bwdps-Photo-Stack' ),
					'style12' => esc_html__( 'Style 12', 'bwdps-Photo-Stack' ),
					'style13' => esc_html__( 'Style 13', 'bwdps-Photo-Stack' ),
					'style14' => esc_html__( 'Style 14', 'bwdps-Photo-Stack' ),
					'style15' => esc_html__( 'Style 15', 'bwdps-Photo-Stack' ),
					'style16' => esc_html__( 'Style 16', 'bwdps-Photo-Stack' ),
					'style17' => esc_html__( 'Style 17', 'bwdps-Photo-Stack' ),
					'style18' => esc_html__( 'Style 18', 'bwdps-Photo-Stack' ),
					'style19' => esc_html__( 'Style 19', 'bwdps-Photo-Stack' ),
					'style20' => esc_html__( 'Style 20', 'bwdps-Photo-Stack' ),
					'style21' => esc_html__( 'Style 21', 'bwdps-Photo-Stack' ),
				],
			]
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'bwdps_photo_stack_section',
			[
				'label' => esc_html__( 'Photo Stack', 'bwdps-Photo-Stack' ),
				'tab' => \Elementor\Controls_Manager::TAB_CONTENT,
			]
		);

		//media
		$this->add_control(
			'bwdps_photostack_single_image',
			[
				'label'   => __('Choose Image', 'bwdps-Photo-Stack'),
				'type' => \Elementor\Controls_Manager::MEDIA,
				'default' => [
					'url' => plugin_dir_url(__DIR__).'assets/public/image/img10.webp',
				],
				'condition' => [
					'bwdps_style_selection!' => ['style1','style2', 'style3', 'style4', 'style5', 'style6', 'style7', 'style8', 'style9', 'style10', 'style11', 'style14', 'style16', 'style17', 'style19', 'style20', 'style21'],
				],
			]
		);

		$repeater = new \Elementor\Repeater();

		//media
		$repeater->add_control(
			'bwdps_photostack_image',
			[
				'type' => \Elementor\Controls_Manager::MEDIA,
				'default' => [
					'url' => \Elementor\Utils::get_placeholder_image_src(),
				],
			]
		);

		//all masking image
		$repeater->add_control(
			'bwdps_maskink_image',
			[
				'label' => esc_html__( 'Masking Effect', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'mask_none',
				'options' => [
					'mask_none' => esc_html__('None', 'bwdps-Photo-Stack'),
					'mask_1'  => esc_html__( 'mask 1', 'bwdps-Photo-Stack' ),
					'mask_2'  => esc_html__( 'mask 2', 'bwdps-Photo-Stack' ),
					'mask_3'  => esc_html__( 'mask 3', 'bwdps-Photo-Stack' ),
					'mask_4'  => esc_html__( 'mask 4', 'bwdps-Photo-Stack' ),
					'mask_5'  => esc_html__( 'mask 5', 'bwdps-Photo-Stack' ),
					'mask_6'  => esc_html__( 'mask 6', 'bwdps-Photo-Stack' ),
					'mask_7'  => esc_html__( 'mask 7', 'bwdps-Photo-Stack' ),
					'mask_8'  => esc_html__( 'mask 8', 'bwdps-Photo-Stack' ),
					'mask_9'  => esc_html__( 'mask 9', 'bwdps-Photo-Stack' ),
					'mask_10'  => esc_html__( 'mask 10', 'bwdps-Photo-Stack' ),
					'mask_11'  => esc_html__( 'mask 11', 'bwdps-Photo-Stack' ),
					'mask_12'  => esc_html__( 'mask 12', 'bwdps-Photo-Stack' ),
					'mask_13'  => esc_html__( 'mask 13', 'bwdps-Photo-Stack' ),
					'mask_14'  => esc_html__( 'mask 14', 'bwdps-Photo-Stack' ),
					'mask_15'  => esc_html__( 'mask 15', 'bwdps-Photo-Stack' ),
					'mask_16'  => esc_html__( 'mask 16', 'bwdps-Photo-Stack' ),
					'mask_17'  => esc_html__( 'mask 17', 'bwdps-Photo-Stack' ),
					'mask_18'  => esc_html__( 'mask 18', 'bwdps-Photo-Stack' ),
					'mask_19'  => esc_html__( 'mask 19', 'bwdps-Photo-Stack' ),
					'mask_20'  => esc_html__( 'mask 20', 'bwdps-Photo-Stack' ),
					'mask_21'  => esc_html__( 'mask 21', 'bwdps-Photo-Stack' ),
					'mask_22'  => esc_html__( 'mask 22', 'bwdps-Photo-Stack' ),
					'mask_23'  => esc_html__( 'mask 23', 'bwdps-Photo-Stack' ),
					'mask_24'  => esc_html__( 'mask 24', 'bwdps-Photo-Stack' ),
					'mask_25'  => esc_html__( 'mask 25', 'bwdps-Photo-Stack' ),
					'mask_26'  => esc_html__( 'mask 26', 'bwdps-Photo-Stack' ),
					'mask_27'  => esc_html__( 'mask 27', 'bwdps-Photo-Stack' ),
					'mask_28'  => esc_html__( 'mask 28', 'bwdps-Photo-Stack' ),
					'mask_29'  => esc_html__( 'mask 29', 'bwdps-Photo-Stack' ),
					'mask_30'  => esc_html__( 'mask 30', 'bwdps-Photo-Stack' ),
					'mask_31'  => esc_html__( 'mask 31', 'bwdps-Photo-Stack' ),
					'mask_32'  => esc_html__( 'mask 32', 'bwdps-Photo-Stack' ),
					'mask_33'  => esc_html__( 'mask 33', 'bwdps-Photo-Stack' ),
					'mask_34'  => esc_html__( 'mask 34', 'bwdps-Photo-Stack' ),
					'mask_35'  => esc_html__( 'mask 35', 'bwdps-Photo-Stack' ),
					'mask_36'  => esc_html__( 'mask 36', 'bwdps-Photo-Stack' ),
					'mask_37'  => esc_html__( 'mask 37', 'bwdps-Photo-Stack' ),
					'mask_38'  => esc_html__( 'mask 38', 'bwdps-Photo-Stack' ),
					'mask_39'  => esc_html__( 'mask 39', 'bwdps-Photo-Stack' ),
				],
			]
		);

		//image-link
		$repeater->add_control(
			'bwdps_photostack_image_link',
			[
				'label' => esc_html__( 'Image Link', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::URL,
				'placeholder' => esc_html__( 'https://example.com', 'bwdps-Photo-Stack' ),
				'label_block' => true,
				'dynamic' => [
					'active' => true,
				],
			]
		);

		//alt-text
		$repeater->add_control(
			'bwdps_alt_text', 
			[
				'label' => esc_html__( 'ALT Text', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::TEXT,
				'default' => esc_html__( 'Item' , 'bwdps-Photo-Stack' ),	
				'label_block' => true,
				'dynamic' => [
					'active' => true,
				],
			]
		);

		//bwdps_imgcontrol_switcher
		$repeater->add_control(
			'bwdps_imgcontrol_switcher',
			[
				'label' => esc_html__( 'Image Control', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::SWITCHER,
				'label_on' => esc_html__( 'Show', 'bwdps-Photo-Stack' ),
				'label_off' => esc_html__( 'Hide', 'bwdps-Photo-Stack' ),
				'return_value' => 'yes',
				'default' => 'no',
				'separator' => 'before',
			]
		);

		//image-width
        $repeater->add_responsive_control(
			'bwdps_photostack_width',
			[
				'label' => esc_html__( 'Width', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item' => 'width: {{SIZE}}{{UNIT}};',
				],
				'separator' => 'before',
				'condition' => [
					'bwdps_imgcontrol_switcher' => 'yes'
				],
			]
		);

		//image-height
        $repeater->add_responsive_control(
			'bwdps_photostack_height',
			[
				'label' => esc_html__( 'Height', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item' => 'height: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'bwdps_imgcontrol_switcher' => 'yes'
				],
			]
		);

		//z-index
		$repeater->add_responsive_control(
            'bwdps_image_z_index',
            [
                'label'     => esc_html__('Z-Index', 'bwdps-Photo-Stack'),
                'type'      => Controls_Manager::NUMBER,
                'min'       => -1000,
                'max'       => 1000,
                'step'      => 1,
                'selectors' => [
                    '{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item' => 'z-index: {{VALUE}};',
                ],
                'condition' => [
					'bwdps_imgcontrol_switcher' => 'yes'
				],
            ]
        );

		//Image Object Opsition
		$repeater->add_control(
			'bwdps_image_object_opsition',
			[
				'label' => esc_html__( 'Image Object Opsition', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::SELECT,
				'default' => 'center',
				'options' => [
					'top'  => esc_html__( 'Top', 'bwdps-Photo-Stack' ),
					'right'  => esc_html__( 'Right', 'bwdps-Photo-Stack' ),
					'bottom'  => esc_html__( 'Bottom', 'bwdps-Photo-Stack' ),
					'center'  => esc_html__( 'Center', 'bwdps-Photo-Stack' ),
				],
				'selectors'   => [
                    '{{WRAPPER}} img' => 'object-position: {{value}}',
                ],
				'condition' => [
					'bwdps_imgcontrol_switcher' => 'yes'
				],
			]
		);

		//position-heading
		$repeater->add_control(
			'bwdps_photostack_image_heading',
			[
				'label' => esc_html__( 'Image Position', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::HEADING,
				'separator' => 'before',
				'condition' => [
					'bwdps_imgcontrol_switcher' => 'yes'
				],
			]
		);
		//top
		$repeater->add_responsive_control(
			'bwdps_photostack_top',
			[
				'label' => esc_html__( 'Offset Y', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => -1000,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => -1000,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item' => 'top: {{SIZE}}{{UNIT}};',
				],
				'separator' => 'before',
				'condition' => [
					'bwdps_imgcontrol_switcher' => 'yes'
				],
			]
		);

		$repeater->add_responsive_control(
			'bwdps_photostack_left',
			[
				'label' => esc_html__( 'Offset X', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => -1000,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => -1000,
						'max' => 1000,
					],
				],
				'selectors' => [
					'{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item' => 'left: {{SIZE}}{{UNIT}};',
				],
				'condition' => [
					'bwdps_imgcontrol_switcher' => 'yes'
				],
			]
		);

		//norlam-hover-tab
		$repeater->start_controls_tabs(
			'style_tabs',
            [
                'separator' => 'before',
				'condition' => [
					'bwdps_imgcontrol_switcher' => 'yes'
				],
            ]
		);

		//highlight-normal-style------------------------------------------
		$repeater->start_controls_tab(
			'style_normal_tab',
			[
				'label' => esc_html__( 'Normal', 'bwdps-Photo-Stack' ),
			]
		);

		//border
		$repeater->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdps_photostack_border',
				'label' => esc_html__( 'Border', 'bwdps-Photo-Stack' ),
				'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item img',
			]
		);

		//Border Radius
		$repeater->add_responsive_control(
			'bwdps_photostack_border-radius',
			[
				'label' => esc_html__( 'Border Radius', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item img' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$repeater->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdps_box_shadow_photostack',
				'label' => esc_html__( 'Box Shadow', 'bwdps-Photo-Stack' ),
				'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item img',
			]
		);

		$repeater->end_controls_tab();

		//highlight-hover-style------------------------------------------
		$repeater->start_controls_tab(
			'style_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwdps-Photo-Stack' ),
			]
		);

		//border
		$repeater->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdps_photostack_border_hover',
				'label' => esc_html__( 'Border', 'bwdps-Photo-Stack' ),
				'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item img:hover',
			]
		);

		 //Border Radius
		 $repeater->add_responsive_control(
			'bwdps_photostack_border-radius_hover',
			[
				'label' => esc_html__( 'Border Radius', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item img:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$repeater->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdps_box_shadow_photostack_hover',
				'label' => esc_html__( 'Box Shadow', 'bwdps-Photo-Stack' ),
				'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}.bwdps_photo_stack_item img:hover',
			]
		);

		$repeater->end_controls_tab();
		$repeater->end_controls_tabs();

		//four-image-repeater
		$this->add_control(
			'bwdps-photostack-section',
			[
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater->get_controls(),
				'default' => [
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx1.webp',
                        ],
					],
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx2.webp',
                        ],
					],
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx3.webp',
                        ],
					],
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx4.webp',
                        ],
					],
				],
				'condition' => [
					'bwdps_style_selection!' => ['style2', 'style3', 'style4', 'style6', 'style8', 'style9', 'style10', 'style11', 'style12', 'style13', 'style14', 'style15', 'style17', 'style19', 'style20', 'style21'],
				],
				'title_field' => '{{{ bwdps_alt_text }}}',
			]
		);

		//three-image-repeater
		$this->add_control(
			'bwdps-photostack-three-section',
			[
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater->get_controls(),
				'default' => [
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx1.webp',
                        ],
					],
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx2.webp',
                        ],
					],
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx3.webp',
                        ],
					],
				],
				'condition' => [
					'bwdps_style_selection!' => ['style1', 'style5', 'style7', 'style8', 'style11', 'style12', 'style13', 'style15', 'style16', 'style17', 'style18'],
				],
				'title_field' => '{{{ bwdps_alt_text }}}',
			]
		);

		//five-image-repeater
		$this->add_control(
			'bwdps-photostack-five-section',
			[
				'type' => \Elementor\Controls_Manager::REPEATER,
				'fields' => $repeater->get_controls(),
				'default' => [
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx1.webp',
                        ],
					],
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx2.webp',
                        ],
					],
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx3.webp',
                        ],
					],
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx4.webp',
                        ],
					],
					[
						'bwdps_alt_text' => esc_html__( 'Item', 'bwdps-Photo-Stack' ),
						'bwdps_photostack_image' => [
                            'url' => plugin_dir_url(__DIR__).'assets/public/image/imgx5.webp',
                        ],
					],
				],
				'condition' => [
					'bwdps_style_selection!' => ['style1', 'style2', 'style3', 'style4', 'style5', 'style6', 'style7', 'style9', 'style10', 'style14', 'style16', 'style18', 'style19', 'style21'],
				],
				'title_field' => '{{{ bwdps_alt_text }}}',
			]
		);

		$this->end_controls_section();



		//tab-content
		$this->start_controls_section(
			'bwdps_tab_style_section',
			[
				'label' => esc_html__( 'Photo Stack Common', 'bwdps-Photo-Stack' ),
				'tab' => \Elementor\Controls_Manager::TAB_STYLE,
			]
		);

		//Infinite Animation
		$this->add_control(
            'image_infinite_animation',
            [
                'label'     => esc_html__('Infinite Animation', 'bwdps-Photo-Stack'),
                'type'      => Controls_Manager::SELECT,
                'options'   => [
                    ''                    => esc_html__('None', 'bwdps-Photo-Stack'),
                    'bwdps-bounce-sm'        => esc_html__('Bounce Small', 'bwdps-Photo-Stack'),
                    'bwdps-bounce-md'        => esc_html__('Bounce Medium', 'bwdps-Photo-Stack'),
                    'bwdps-bounce-lg'        => esc_html__('Bounce Large', 'bwdps-Photo-Stack'),
                    'bwdps-fade'             => esc_html__('Fade', 'bwdps-Photo-Stack'),
                    'bwdps-rotating'         => esc_html__('Rotating', 'bwdps-Photo-Stack'),
                    'bwdps-rotating-inverse' => esc_html__('Rotating inverse', 'bwdps-Photo-Stack'),
                    'bwdps-scale-sm'         => esc_html__('Scale Small', 'bwdps-Photo-Stack'),
                    'bwdps-scale-md'         => esc_html__('Scale Medium', 'bwdps-Photo-Stack'),
                    'bwdps-scale-lg'         => esc_html__('Scale Large', 'bwdps-Photo-Stack'),
                ],
                'default'   => 'bwdps-bounce-sm',
                'separator' => 'before',
            ]
        );

		//animation_speed
		$this->add_control(
			'bwdps_animation_speed',
			[
				'label'       => esc_html__('Infinite Animation speed', 'bwdps-Photo-Stack'),
				'type'        => Controls_Manager::NUMBER,
				'min'         => 0,
				'max'         => 100,
				'step'        => .1,
				'default'     => 6,
				'selectors'   => [
					'{{WRAPPER}} .bwdps_photo_stack_wrap' => '--animation_speed:{{SIZE}}s',
				],
			]
		);

		//hover amination
		$this->add_control(
            'bwdps_hover_animation_style',
            [
                'label'     => esc_html__('Hover Animation', 'bwdps-Photo-Stack'),
                'type'      => Controls_Manager::SELECT,
                'options'   => [
                    'none'             => esc_html__('None', 'bwdps-Photo-Stack'),
                    'fly-sm'           => esc_html__('Fly Small', 'bwdps-Photo-Stack'),
                    'fly'              => esc_html__('Fly Medium', 'bwdps-Photo-Stack'),
                    'fly-lg'           => esc_html__('Fly Large', 'bwdps-Photo-Stack'),
                    'scale-sm'         => esc_html__('Scale Small', 'bwdps-Photo-Stack'),
                    'scale'            => esc_html__('Scale Medium', 'bwdps-Photo-Stack'),
                    'scale-lg'         => esc_html__('Scale Large', 'bwdps-Photo-Stack'),
                    'scale-inverse-sm' => esc_html__('Scale Inverse Small', 'bwdps-Photo-Stack'),
                    'scale-inverse'    => esc_html__('Scale Inverse Medium', 'bwdps-Photo-Stack'),
                    'scale-inverse-lg' => esc_html__('Scale Inverse Large', 'bwdps-Photo-Stack'),
                    'bounce' => esc_html__('Bounce', 'bwdps-Photo-Stack'),
                ],
                'default'   => 'scale-sm',
            ]
        );

		//extra hover amination
		$this->add_control(
            'bwdps_extra_hover_animation_style',
            [
                'label'     => esc_html__('Extra Hover Animation', 'bwdps-Photo-Stack'),
				'description' => esc_html__('Notice: if you use [ Extra Hover Animation ] control, please turn off [ Hover Animation ] control. Thank You', 'bwdps-Photo-Stack'),
                'type'      => Controls_Manager::SELECT,
                'options'   => [
                    'bnone' => esc_html__('None', 'bwdps-Photo-Stack'),
                    'bounce' => esc_html__('bounce', 'bwdps-Photo-Stack'),
					'bounceIn' => esc_html__('BounceIn', 'bwdps-Photo-Stack'),
					'bounceOut' => esc_html__('BounceOut', 'bwdps-Photo-Stack'),
                    'flash' => esc_html__('Flash', 'bwdps-Photo-Stack'),
                    'pulse' => esc_html__('Pulse', 'bwdps-Photo-Stack'),
                    'rubberBand' => esc_html__('RubberBand', 'bwdps-Photo-Stack'),
                    'shakeX' => esc_html__('ShakeX', 'bwdps-Photo-Stack'),
                    'shakeY' => esc_html__('ShakeY', 'bwdps-Photo-Stack'),
                    'headShake' => esc_html__('HeadShake', 'bwdps-Photo-Stack'),
                    'swing' => esc_html__('Swing', 'bwdps-Photo-Stack'),
                    'tada' => esc_html__('Tada', 'bwdps-Photo-Stack'),
                    'wobble' => esc_html__('Wobble', 'bwdps-Photo-Stack'),
                    'jello' => esc_html__('Jello', 'bwdps-Photo-Stack'),
                    'heartBeat' => esc_html__('HeartBeat', 'bwdps-Photo-Stack'),
                    'fadeOut' => esc_html__('FadeOut', 'bwdps-Photo-Stack'),
                    'flip' => esc_html__('Flip', 'bwdps-Photo-Stack'),
                    'flipInX' => esc_html__('FlipInX', 'bwdps-Photo-Stack'),
                    'flipInY' => esc_html__('FlipInY', 'bwdps-Photo-Stack'),
                    'rotateIn' => esc_html__('RotateIn', 'bwdps-Photo-Stack'),
                    'rotateOut' => esc_html__('RotateOut', 'bwdps-Photo-Stack'),
                    'hinge' => esc_html__('Hinge', 'bwdps-Photo-Stack'),
                    'jackInTheBox' => esc_html__('JackInTheBox', 'bwdps-Photo-Stack'),
                    'zoomIn' => esc_html__('ZoomIn', 'bwdps-Photo-Stack'),
                    'zoomOut' => esc_html__('ZoomOut', 'bwdps-Photo-Stack'),
                ],
                'default'   => 'bnone',
				'selectors'   => [
                    '{{WRAPPER}} .bwdps_photo_stack_item:hover img' => 'animation-name: {{value}}',
                ],
            ]
        );

		//hover animation_speed
		$this->add_control(
			'bwdps_hover_animation_speed',
			[
				'label'       => esc_html__('Hover Animation speed', 'bwdps-Photo-Stack'),
				'type'        => Controls_Manager::NUMBER,
				'min'         => 0,
				'max'         => 100,
				'step'        => .1,
				'default'     => .4,
				'selectors'   => [
					'{{WRAPPER}} .bwdps_photo_stack_item img' => 'animation-duration:{{SIZE}}s',
				],
			]
		);

		//image-width
		$this->add_responsive_control(
			'bwdps_photostack_common_width',
			[
				'label' => esc_html__( 'Width', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdps_photo_stack_wrap' => 'width: {{SIZE}}{{UNIT}};',
				],
				'separator' => 'before',
			]
		);

		//image-height
		$this->add_responsive_control(
			'bwdps_photostack_common_height',
			[
				'label' => esc_html__( 'Height', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::SLIDER,
				'size_units' => [ 'px', '%' ],
				'range' => [
					'px' => [
						'min' => 0,
						'max' => 1000,
						'step' => 1,
					],
					'%' => [
						'min' => 0,
						'max' => 100,
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdps_photo_stack_wrap' => 'min-height: {{SIZE}}{{UNIT}};',
				],
			]
		);

		//overflow
		$this->add_responsive_control(
            'bwdps_photostack_overflow',
            [
                'label'     => esc_html__('Overflow', 'bwdps-Photo-Stack'),
                'type'      => Controls_Manager::SELECT,
                'options'   => [
					'visible' => esc_html__('Visible', 'bwdps-Photo-Stack'),
                    'hidden'  => esc_html__('Hidden', 'bwdps-Photo-Stack'),
                    'scroll'  => esc_html__('Scroll', 'bwdps-Photo-Stack'),
				],
                'default'   => 'visible',
                'selectors' => [
					'{{WRAPPER}} .bwdps_photo_stack_wrap' => 'overflow: {{VALUE}}',
				],
            ]
        );

		//alignment
		$this->add_responsive_control(
			'bwdps_photostack_alignment',
			[
				'label' => esc_html__( 'Alignment', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::CHOOSE,
				'options' => [
					'left' => [
						'title' => esc_html__( 'Left', 'bwdps-Photo-Stack' ),
						'icon' => 'eicon-text-align-left',
					],
					'center' => [
						'title' => esc_html__( 'Center', 'bwdps-Photo-Stack' ),
						'icon' => 'eicon-text-align-center',
					],
					'right' => [
						'title' => esc_html__( 'Right', 'bwdps-Photo-Stack' ),
						'icon' => 'eicon-text-align-right',
					],
				],
				'selectors' => [
					'{{WRAPPER}} .bwdps_photostack_alignment' => 'text-align: {{VALUE}}',
				],
				'toggle' => true,
			]
		);

		//norlam-hover-tab-------------------------------------
		$this->start_controls_tabs(
			'style_tabs',
			[
				'separator' => 'before',
			]
		);

		//highlight-normal-style------------------------------------------
		$this->start_controls_tab(
			'style_normal_tab',
			[
				'label' => esc_html__( 'Normal', 'bwdps-Photo-Stack' ),
			]
		);

		//border
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdps_photostack_border_comn',
				'label' => esc_html__( 'Border', 'bwdps-Photo-Stack' ),
				'selector' => '{{WRAPPER}} .bwdps_photo_stack_item img',
			]
		);

		//Border Radius
		$this->add_responsive_control(
			'bwdps_photostack_border-radius_comn',
			[
				'label' => esc_html__( 'Border Radius', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .bwdps_photo_stack_item img' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdps_box_shadow_photostack_comn',
				'label' => esc_html__( 'Box Shadow', 'bwdps-Photo-Stack' ),
				'selector' => '{{WRAPPER}} .bwdps_photo_stack_item img',
			]
		);

		$this->end_controls_tab();

		//highlight-hover-style------------------------------------------
		$this->start_controls_tab(
			'style_hover_tab',
			[
				'label' => esc_html__( 'Hover', 'bwdps-Photo-Stack' ),
			]
		);

		//border
		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			[
				'name' => 'bwdps_photostack_border_hover_comn',
				'label' => esc_html__( 'Border', 'bwdps-Photo-Stack' ),
				'selector' => '{{WRAPPER}} .bwdps_photo_stack_item img:hover',
			]
		);

		//Border Radius
		$this->add_responsive_control(
			'bwdps_photostack_border-radius_hover_comn',
			[
				'label' => esc_html__( 'Border Radius', 'bwdps-Photo-Stack' ),
				'type' => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => [ 'px', '%', 'em' ],
				'selectors' => [
					'{{WRAPPER}} .bwdps_photo_stack_item img:hover' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				],
			]
		);

		//Box Shadow
		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			[
				'name' => 'bwdps_box_shadow_photostack_hover_comn',
				'label' => esc_html__( 'Box Shadow', 'bwdps-Photo-Stack' ),
				'selector' => '{{WRAPPER}} .bwdps_photo_stack_item img:hover',
			]
		);

		$this->end_controls_tab();
		$this->end_controls_tabs();

		$this->end_controls_section();

  
	}


	protected function render(){

		$settings = $this->get_settings_for_display();

		$bwdps_style_selection = $settings['bwdps_style_selection'];

        if ( ! empty( $settings['bwdps_photostack_image_link']['url'] ) ) {
			$this->add_link_attributes( 'bwdps_photostack_image_link', $settings['bwdps_photostack_image_link'] );
		}




		if( 'style1' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_1 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
					<?php
					if ( $settings['bwdps-photostack-section'] ) {
						foreach (  $settings['bwdps-photostack-section'] as $item ) {
					?>
						<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
					<?php } } ?>
				</div>
			</div>
			<?php
		} elseif( 'style2' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_2 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-three-section'] ) {
						foreach (  $settings['bwdps-photostack-three-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style3' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_3 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-three-section'] ) {
						foreach (  $settings['bwdps-photostack-three-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style4' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_4 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-three-section'] ) {
						foreach (  $settings['bwdps-photostack-three-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style5' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_5 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
					<?php
					if ( $settings['bwdps-photostack-section'] ) {
						foreach (  $settings['bwdps-photostack-section'] as $item ) {
					?>
						<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
					<?php } } ?>
				</div>
			</div>
			<?php
		} elseif( 'style6' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_6 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-three-section'] ) {
						foreach (  $settings['bwdps-photostack-three-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style7' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_6 bwdps_photo_stack_7 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-section'] ) {
						foreach (  $settings['bwdps-photostack-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style8' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_8 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-five-section'] ) {
						foreach (  $settings['bwdps-photostack-five-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style9' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_9 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-three-section'] ) {
						foreach (  $settings['bwdps-photostack-three-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style10' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_10 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-three-section'] ) {
						foreach (  $settings['bwdps-photostack-three-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style11' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_11 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-five-section'] ) {
						foreach (  $settings['bwdps-photostack-five-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style12' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_12 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap <?php echo esc_attr( $settings['image_infinite_animation'] ); ?>" style="background-image: url(<?php echo esc_url( $settings['bwdps_photostack_single_image']['url'] ); ?>);">
				<?php
					if ( $settings['bwdps-photostack-five-section'] ) {
						foreach (  $settings['bwdps-photostack-five-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style13' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_13 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap <?php echo esc_attr( $settings['image_infinite_animation'] ); ?>" style="background-image: url(<?php echo esc_url( $settings['bwdps_photostack_single_image']['url'] ); ?>);">
				<?php
					if ( $settings['bwdps-photostack-five-section'] ) {
						foreach (  $settings['bwdps-photostack-five-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style14' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_2 bwdps_photo_stack_14 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-three-section'] ) {
						foreach (  $settings['bwdps-photostack-three-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style15' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_15 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap <?php echo esc_attr( $settings['image_infinite_animation'] ); ?>" style="background-image: url(<?php echo esc_url( $settings['bwdps_photostack_single_image']['url'] ); ?>);">
				<?php
					if ( $settings['bwdps-photostack-five-section'] ) {
						foreach (  $settings['bwdps-photostack-five-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style16' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_16 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
					<?php
					if ( $settings['bwdps-photostack-section'] ) {
						foreach (  $settings['bwdps-photostack-section'] as $item ) {
					?>
						<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
					<?php } } ?>
				</div>
			</div>
			<?php
		} elseif( 'style17' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_17 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-five-section'] ) {
						foreach (  $settings['bwdps-photostack-five-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style18' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_18 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap <?php echo esc_attr( $settings['image_infinite_animation'] ); ?>" style="background-image: url(<?php echo esc_url( $settings['bwdps_photostack_single_image']['url'] ); ?>);">
					<?php
					if ( $settings['bwdps-photostack-section'] ) {
						foreach (  $settings['bwdps-photostack-section'] as $item ) {
					?>
						<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
					<?php } } ?>
				</div>
			</div>
			<?php
		} elseif( 'style19' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_19 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-three-section'] ) {
						foreach (  $settings['bwdps-photostack-three-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style20' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_19 bwdps_photo_stack_20 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-five-section'] ) {
						foreach (  $settings['bwdps-photostack-five-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		} elseif( 'style21' === $bwdps_style_selection ) { ?>
			<div class="bwdps_photo_stack_21 bwdps_photostack_alignment">
				<div class="bwdps_photo_stack_wrap">
				<?php
					if ( $settings['bwdps-photostack-three-section'] ) {
						foreach (  $settings['bwdps-photostack-three-section'] as $item ) {
				?>
					<div class="bwdps_photo_stack_item elementor-repeater-item-<?php echo esc_attr( $item['_id'] ); ?> <?php echo esc_attr( $settings['image_infinite_animation'] ); ?> <?php echo esc_attr( $item['bwdps_maskink_image'] ); ?>">

						<a class="bwdps_anchor" href="<?php echo esc_url( $item['bwdps_photostack_image_link']['url'] ); ?>">
							<img class="<?php echo esc_attr( $settings['bwdps_hover_animation_style'] ); ?>" src="<?php echo esc_attr( $item['bwdps_photostack_image']['url'] ); ?>" alt="<?php echo esc_html( $item['bwdps_alt_text'] ); ?>">
						</a>
					</div>
				<?php } } ?>
				</div>
        	</div>
			<?php
		}

	}
}
